<?php 
// Textfelder einlesen
$eingabefehler = "";
$title = isset($_POST["title"]) ? $_POST["title"] : "";
$username = isset($_POST["username"]) ? $_POST["username"] : "";
$text = isset($_POST["text"]) ? $_POST["text"] : "";

// Formular erzeugen
$formular =
'<table id="form">
    <form action="new.php" method="post">
        <tr>
            <td colspan="2" style="text-align: center; color: #FF0000;"><!-- ERRORS ARE SHOWN HERE --></td>
        </tr>
        <tr>
            <td><b>Titel:</b></td>
            <td><input type="text" name="title" size="80" value="'.$title.'" /></td>
        </tr>
        <tr>
            <td><b>Username:</b></td>
            <td><input type="text" name="username" size="40" value="'.$username.'" /></td>
        </tr>
        <tr>
            <td><b>Text:</b></td>
            <td><textarea name="text" rows="10" cols="62" style="resize: none;">'.$text.'</textarea></td>
        </tr>
        <tr>
            <td colspan="2" style="text-align: center;"><input type="submit" value="Thema erstellen" /></td>
        </tr>
    </form>
</table>';

// Prüfen, ob Formulardaten übertragen wurden
if ($_SERVER['REQUEST_METHOD'] == "POST")
{
    // Eingaben auf Fehler prüfen
    if (strlen($title) < 10)
        $eingabefehler .= "<br />&bull; Der Titel ist zu kurz (10 - 80 Zeichen).";
    if (strlen($title) > 80)
        $eingabefehler .= "<br />&bull; Der Titel ist zu lang (10 - 80 Zeichen).";
    if (strlen($username) < 5)
        $eingabefehler .= "<br />&bull; Der Benutzername ist zu kurz (5 - 30 Zeichen).";
    if (strlen($username) > 30)
        $eingabefehler .= "<br />&bull; Der Benutzername ist zu lang (5 - 30 Zeichen).";
    if (strlen($text) < 25)
        $eingabefehler .= "<br />&bull; Der Text ist zu kurz (min. 25 Zeichen).";
    
    // Prüfen, ob keine Fehler gefunden wurden
    if ($eingabefehler == "")
    {
        // Sonderzeichen behandeln
        $title = str_replace("!!!##+##!!!", "", $title);
        $title = str_replace(array("\r\n", "\r", "\n"), "", $title);
        $title = htmlspecialchars($title, ENT_QUOTES | ENT_HTML5, "UTF-8");
        $username = str_replace("!!!##+##!!!", "", $username);
        $username = str_replace(array("\r\n", "\r", "\n"), "", $username);
        $username = htmlspecialchars($username, ENT_QUOTES | ENT_HTML5, "UTF-8");
        $text = str_replace("!!!##+##!!!", "", $text);
        $text = htmlspecialchars($text, ENT_QUOTES | ENT_HTML5, "UTF-8");
        $text = str_replace(array("\r\n", "\r", "\n"), "<br />", $text);
        
        // BB-Codes behandeln
        $text = preg_replace("/\[b\](.*)\[\/b\]/Usi", "<b>\\1</b>", $text);
        $text = preg_replace("/\[i\](.*)\[\/i\]/Usi", "<i>\\1</i>", $text);
        $text = preg_replace("/\[s\](.*)\[\/s\]/Usi", "<s>\\1</s>", $text);
        $text = preg_replace("/\[url\](.*)\[\/url\]/Usi", "<a href=\"\\1\">\\1</a>", $text);
        $text = preg_replace("/\[mail\](.*)\[\/mail\]/Usi", "<a href=\"mailto:\\1\">\\1</a>", $text);
        
        // Nummer dieses Themas ermitteln
        $titlenumber = count(file("titlelist.txt")) + 1;
        
        // Titel in Titelliste aufnehmen
        $titlelisthandler = fopen("titlelist.txt", "a");
        fwrite($titlelisthandler, $title."\r\n");
        fclose($titlelisthandler);
        
        // Datensatz erstellen
        file_put_contents("dataset/".sprintf("%04d", $titlenumber).".txt", $title."!!!##+##!!!".$username."!!!##+##!!!".date("d.m.Y H:i")."!!!##+##!!!".$text);
        
        // Antwort-Zähler erstellen
        file_put_contents("counter/".sprintf("%04d", $titlenumber).".txt", "0");
        
        // Weiterleitung auf Themenseite
        header("Location: viewtopic.php?id=".sprintf("%04d", $titlenumber));
        exit();
    }
    // Fehler in Formular einsetzen
    else
        $formular = str_replace('<!-- ERRORS ARE SHOWN HERE -->', '<span style="padding: 10px 0;"><b>Folgende Fehler sind aufgetreten:</b>'.$eingabefehler.'</span>', $formular);
}
 ?>
<!Doctype html>

<html>
    <head>
        <title>Thema erstellen - Forum - Projekte - Homepage-Webhilfe</title>
        
        <meta charset="UTF-8" />
        <meta name="author" content="Homepage-Webhilfe, Benjamin Jung" />
        
        <link type="text/css" rel="stylesheet" href="style/basic.css" />
        <link type="text/css" rel="stylesheet" href="style/form.css" />
    </head>
    
    <body>
        <div id="forum">
            <div id="top">
                <h1><a href="index.php">Homepage-Webhilfe - Projekt "Forum"</a></h1>
                <h2>Neues Thema erstellen</h2>
            </div>
            
            <?php echo $formular; ?>
            
            <div id="bottom">
                &copy; Copyright 2014-2017 by Homepage-Webhilfe, Benjamin Jung
            </div>
        </div>
    </body>
</html>